<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="设备ID" prop="deviceId">
        <el-select
          v-model="formData.deviceId"
          placeholder="请选择设备ID"
          clearable
          filterable
          remote
          :remote-method="queryDevices"
          :loading="deviceLoading"
        >
          <el-option
            v-for="device in deviceOptions"
            :key="device.id"
            :label="device.deviceName"
            :value="device.id"
          />
        </el-select>

      </el-form-item>
      <el-form-item label="资料分类" prop="model">
        <el-select v-model="formData.model" placeholder="请选择资料分类">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.DEVICE_FILES_MODEL)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="资料名称" prop="fileName">
        <el-input v-model="formData.fileName" placeholder="请输入资料名称" />
      </el-form-item>
      <el-form-item label="资料路径" prop="fileUrl">
        <UploadFile v-model="formData.fileUrl" :limit="1" :file-size="100"  />
      </el-form-item>
      <el-form-item label="显示顺序" prop="sort">
        <el-input v-model="formData.sort" placeholder="请输入显示顺序" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getIntDictOptions, DICT_TYPE } from '@/utils/dict'
import { FilesApi, FilesVO } from '@/api/device/files'
import { InfoApi, InfoVO } from '@/api/device/info'

/** 设备资料 表单 */
defineOptions({ name: 'FilesForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  deviceId: undefined,
  model: undefined,
  fileName: undefined,
  fileUrl: undefined,
  sort: undefined,
})
const formRules = reactive({
  deviceId: [{ required: true, message: '设备ID不能为空', trigger: 'blur' }],
  fileName: [{ required: true, message: '资料名称不能为空', trigger: 'blur' }],
  fileUrl: [{ required: true, message: '资料路径不能为空', trigger: 'blur' }],
  sort: [{ required: true, message: '显示顺序不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref
const deviceOptions = ref()
const deviceLoading = ref()

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await FilesApi.getFiles(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as Files
    if (formType.value === 'create') {
      await FilesApi.createFiles(data)
      message.success(t('common.createSuccess'))
    } else {
      await FilesApi.updateFiles(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    deviceId: undefined,
    model: undefined,
    fileName: undefined,
    fileUrl: undefined,
    sort: undefined,
  }
  formRef.value?.resetFields()
}

const queryDevices = async (deviceName?: string) => {
  deviceLoading.value = true
  const { list } = await InfoApi.getInfoPage({ deviceName, pageSize: 10 })
  deviceOptions.value = list
  deviceLoading.value = false
}

</script>
